--- php-8.4.18/ext/standard/tests/file/bug52820.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/tests/file/bug52820.phpt	2026-04-01 04:35:36.020825262 +0000
@@ -45,22 +45,18 @@
 --EXPECTREGEX--
 temp stream \(close after\):
 About to rewind!
-(\* processing: file:\/\/\/i_dont_exist\/\n)?\* (Couldn't|Could not) open file \/i_dont_exist\/
-\* [Cc]losing connection( #?-?\d+)?
+(\* processing: file:\/\/\/i_dont_exist\/\n)?\* (Couldn't|Could not) open file \/i_dont_exist\/(\n\* [Cc]losing connection( #?-?\d+)?)?
 
 memory stream \(close after\):
 About to rewind!
-(\* processing: file:\/\/\/i_dont_exist\/\n)?\* (Couldn't|Could not) open file \/i_dont_exist\/
-\* [Cc]losing connection( #?-?\d+)?
+(\* processing: file:\/\/\/i_dont_exist\/\n)?\* (Couldn't|Could not) open file \/i_dont_exist\/(\n\* [Cc]losing connection( #?-?\d+)?)?
 
 temp stream \(leak\):
 About to rewind!
-(\* processing: file:\/\/\/i_dont_exist\/\n)?\* (Couldn't|Could not) open file \/i_dont_exist\/
-\* [Cc]losing connection( #?-?\d+)?
+(\* processing: file:\/\/\/i_dont_exist\/\n)?\* (Couldn't|Could not) open file \/i_dont_exist\/(\n\* [Cc]losing connection( #?-?\d+)?)?
 
 memory stream \(leak\):
 About to rewind!
-(\* processing: file:\/\/\/i_dont_exist\/\n)?\* (Couldn't|Could not) open file \/i_dont_exist\/
-\* [Cc]losing connection( #?-?\d+)?
+(\* processing: file:\/\/\/i_dont_exist\/\n)?\* (Couldn't|Could not) open file \/i_dont_exist\/(\n\* [Cc]losing connection( #?-?\d+)?)?
 
 Done\.
diff '--color=auto' -Naur php-8.4.18/ext/standard/tests/file/file_get_contents_file_put_contents_5gb.phpt php-8.4.20RC1/ext/standard/tests/file/file_get_contents_file_put_contents_5gb.phpt
--- php-8.4.18/ext/standard/tests/file/file_get_contents_file_put_contents_5gb.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/tests/file/file_get_contents_file_put_contents_5gb.phpt	2026-04-01 04:35:36.020907498 +0000
@@ -2,6 +2,7 @@
 Test file_put_contents() and file_get_contents() functions with 5GB string
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (PHP_INT_SIZE < 5) {
     // 4=4gb, 5=549gb, 8=9exabytes
     die("skip PHP_INT_SIZE<5 will not fit test string in RAM");
diff '--color=auto' -Naur php-8.4.18/ext/standard/tests/general_functions/gh20840.phpt php-8.4.20RC1/ext/standard/tests/general_functions/gh20840.phpt
--- php-8.4.18/ext/standard/tests/general_functions/gh20840.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/tests/general_functions/gh20840.phpt	2026-04-01 04:35:36.020986207 +0000
@@ -12,7 +12,7 @@
 }
 ?>
 --INI--
-zend.max_allowed_stack_size=128K
+zend.max_allowed_stack_size=256K
 --FILE--
 <?php
 class Node {
diff '--color=auto' -Naur php-8.4.18/ext/standard/tests/http/http_build_query/gh20583.phpt php-8.4.20RC1/ext/standard/tests/http/http_build_query/gh20583.phpt
--- php-8.4.18/ext/standard/tests/http/http_build_query/gh20583.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/tests/http/http_build_query/gh20583.phpt	2026-04-01 04:35:36.021066719 +0000
@@ -10,11 +10,11 @@
 }
 ?>
 --INI--
-zend.max_allowed_stack_size=128K
+zend.max_allowed_stack_size=256K
 --FILE--
 <?php
 $a = null;
-for ($i = 0; $i < 1000; $i++) {
+for ($i = 0; $i < 3000; $i++) {
  $a = [$i => $a];
 }
 try {
diff '--color=auto' -Naur php-8.4.18/ext/standard/tests/strings/gh15613.phpt php-8.4.20RC1/ext/standard/tests/strings/gh15613.phpt
--- php-8.4.18/ext/standard/tests/strings/gh15613.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/tests/strings/gh15613.phpt	2026-04-01 04:35:36.021143594 +0000
@@ -2,6 +2,7 @@
 GH-15613 overflow on hex strings repeater value
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (PHP_INT_SIZE != 8) die("skip this test is for 64 bit platform only");
 ?>
 --INI--
diff '--color=auto' -Naur php-8.4.18/ext/standard/tests/strings/gh18976.phpt php-8.4.20RC1/ext/standard/tests/strings/gh18976.phpt
--- php-8.4.18/ext/standard/tests/strings/gh18976.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/tests/strings/gh18976.phpt	2026-04-01 04:35:36.021239585 +0000
@@ -2,6 +2,10 @@
 GH-18976 (pack overflow with h/H format)
 --INI--
 memory_limit=-1
+--SKIPIF--
+<?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
+?>
 --FILE--
 <?php
 pack('h2147483647', 1);
diff '--color=auto' -Naur php-8.4.18/ext/standard/tests/strings/gh20906_1.phpt php-8.4.20RC1/ext/standard/tests/strings/gh20906_1.phpt
--- php-8.4.18/ext/standard/tests/strings/gh20906_1.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/standard/tests/strings/gh20906_1.phpt	2026-04-01 04:35:36.021319156 +0000
@@ -0,0 +1,25 @@
+--TEST--
+GH-20906 (Assertion failure when messing up output buffers) - php_strip_whitespace
+--CREDITS--
+vi3tL0u1s
+--FILE--
+<?php
+class A {
+    function __destruct() {
+        php_strip_whitespace(__FILE__);
+        echo "x";
+        $c = new A;
+        ob_start(function () use ($c) { return '/'; }, 1);
+        ob_start(function () use (&$c) { $c = new A; return '/'; }, 1);
+    }
+}
+
+try {
+  new A;
+} catch (Throwable $e) {
+  echo $e::class, ": ", $e->getMessage(), "\n";
+}
+?>
+--EXPECTF--
+%a
+Fatal error: php_strip_whitespace(): Cannot use output buffering in output buffering display handlers in %s on line %d
diff '--color=auto' -Naur php-8.4.18/ext/standard/tests/strings/gh20906_2.phpt php-8.4.20RC1/ext/standard/tests/strings/gh20906_2.phpt
--- php-8.4.18/ext/standard/tests/strings/gh20906_2.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/standard/tests/strings/gh20906_2.phpt	2026-04-01 04:35:36.021398395 +0000
@@ -0,0 +1,21 @@
+--TEST--
+GH-20906 (Assertion failure when messing up output buffers) - highlight_file
+--CREDITS--
+vi3tL0u1s
+--FILE--
+<?php
+class A {
+    function __destruct() {
+        highlight_file(__FILE__, true);
+        echo "x";
+        $c = new A;
+        ob_start(function () use ($c) { return '/'; }, 1);
+        ob_start(function () use (&$c) { $c = new A; return '/'; }, 1);
+    }
+}
+
+new A;
+?>
+--EXPECTF--
+%a
+Fatal error: highlight_file(): Cannot use output buffering in output buffering display handlers in %s on line %d
diff '--color=auto' -Naur php-8.4.18/ext/standard/tests/strings/gh20906_3.phpt php-8.4.20RC1/ext/standard/tests/strings/gh20906_3.phpt
--- php-8.4.18/ext/standard/tests/strings/gh20906_3.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/standard/tests/strings/gh20906_3.phpt	2026-04-01 04:35:36.021495168 +0000
@@ -0,0 +1,21 @@
+--TEST--
+GH-20906 (Assertion failure when messing up output buffers) - highlight_string
+--CREDITS--
+vi3tL0u1s
+--FILE--
+<?php
+class A {
+    function __destruct() {
+        highlight_string(__FILE__, true);
+        echo "x";
+        $c = new A;
+        ob_start(function () use ($c) { return '/'; }, 1);
+        ob_start(function () use (&$c) { $c = new A; return '/'; }, 1);
+    }
+}
+
+new A;
+?>
+--EXPECTF--
+%a
+Fatal error: highlight_string(): Cannot use output buffering in output buffering display handlers in %s on line %d
diff '--color=auto' -Naur php-8.4.18/ext/standard/user_filters.c php-8.4.20RC1/ext/standard/user_filters.c
--- php-8.4.18/ext/standard/user_filters.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/standard/user_filters.c	2026-04-01 04:35:36.021607741 +0000
@@ -259,8 +259,8 @@
 	len = strlen(filtername);
 
 	/* determine the classname/class entry */
-	if (NULL == (fdat = zend_hash_str_find_ptr(BG(user_filter_map), (char*)filtername, len))) {
-		char *period;
+	if (NULL == (fdat = zend_hash_str_find_ptr(BG(user_filter_map), filtername, len))) {
+		const char *period;
 
 		/* Userspace Filters using ambiguous wildcards could cause problems.
            i.e.: myfilter.foo.bar will always call into myfilter.foo.*
@@ -272,16 +272,16 @@
 
 			/* Search for wildcard matches instead */
 			memcpy(wildcard, filtername, len + 1); /* copy \0 */
-			period = wildcard + (period - filtername);
-			while (period) {
-				ZEND_ASSERT(period[0] == '.');
-				period[1] = '*';
-				period[2] = '\0';
+			char *new_period = wildcard + (period - filtername);
+			while (new_period) {
+				ZEND_ASSERT(new_period[0] == '.');
+				new_period[1] = '*';
+				new_period[2] = '\0';
 				if (NULL != (fdat = zend_hash_str_find_ptr(BG(user_filter_map), wildcard, strlen(wildcard)))) {
-					period = NULL;
+					new_period = NULL;
 				} else {
-					*period = '\0';
-					period = strrchr(wildcard, '.');
+					*new_period = '\0';
+					new_period = strrchr(wildcard, '.');
 				}
 			}
 			efree(wildcard);
@@ -311,7 +311,7 @@
 	}
 
 	/* filtername */
-	add_property_string(&obj, "filtername", (char*)filtername);
+	add_property_string(&obj, "filtername", filtername);
 
 	/* and the parameters, if any */
 	if (filterparams) {
diff '--color=auto' -Naur php-8.4.18/ext/sysvshm/sysvshm.c php-8.4.20RC1/ext/sysvshm/sysvshm.c
--- php-8.4.18/ext/sysvshm/sysvshm.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/sysvshm/sysvshm.c	2026-04-01 04:35:36.021721255 +0000
@@ -309,11 +309,13 @@
 	shm_data = &shm_var->mem;
 
 	PHP_VAR_UNSERIALIZE_INIT(var_hash);
-	if (php_var_unserialize(return_value, (const unsigned char **) &shm_data, (unsigned char *) shm_data + shm_var->length, &var_hash) != 1) {
+	int res = php_var_unserialize(return_value, (const unsigned char **) &shm_data, (unsigned char *) shm_data + shm_var->length, &var_hash);
+	PHP_VAR_UNSERIALIZE_DESTROY(var_hash);
+	if (res != 1) {
 		php_error_docref(NULL, E_WARNING, "Variable data in shared memory is corrupted");
-		RETVAL_FALSE;
+		zval_ptr_dtor(return_value);
+		RETURN_FALSE;
 	}
-	PHP_VAR_UNSERIALIZE_DESTROY(var_hash);
 }
 /* }}} */
 
diff '--color=auto' -Naur php-8.4.18/ext/sysvshm/tests/shm_get_var_leak.phpt php-8.4.20RC1/ext/sysvshm/tests/shm_get_var_leak.phpt
--- php-8.4.18/ext/sysvshm/tests/shm_get_var_leak.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/sysvshm/tests/shm_get_var_leak.phpt	2026-04-01 04:35:36.021805765 +0000
@@ -0,0 +1,37 @@
+--TEST--
+shm_get_var() leaks if variable is corrupted
+--EXTENSIONS--
+sysvshm
+ffi
+--INI--
+ffi.enable=1
+--SKIPIF--
+<?php
+if (!function_exists('ftok')) die('skip needs ftok');
+if (PHP_INT_SIZE !== 8) die('skip only for 64-bit');
+if (PHP_OS_FAMILY !== 'Linux') die('skip only for decent operating systems');
+?>
+--FILE--
+<?php
+
+$key = ftok(__FILE__, 't');
+$s = shm_attach($key, 128);
+
+shm_put_var($s, 0, [1, 2]);
+
+$ffi = FFI::cdef(<<<CODE
+int shmget(int, size_t, int);
+char *shmat(int, const void *, int);
+CODE);
+$ptr = $ffi->shmat($ffi->shmget($key, 0, 0), $ffi->new('void *'), 0);
+
+$ptr[0x40 + 13] = 0; // Corrupt first byte of second element of serialized data
+
+var_dump(shm_get_var($s, 0));
+
+shm_remove($s);
+
+?>
+--EXPECTF--
+Warning: shm_get_var(): Variable data in shared memory is corrupted in %s on line %d
+bool(false)
diff '--color=auto' -Naur php-8.4.18/ext/tidy/tests/parsing_file_too_large.phpt php-8.4.20RC1/ext/tidy/tests/parsing_file_too_large.phpt
--- php-8.4.18/ext/tidy/tests/parsing_file_too_large.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/tidy/tests/parsing_file_too_large.phpt	2026-04-01 04:35:36.021908479 +0000
@@ -4,6 +4,7 @@
 tidy
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (PHP_INT_SIZE != 8) die("skip this test is for 64bit platform only");
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
 if (getenv("SKIP_ASAN")) die("skip too big for asan");
diff '--color=auto' -Naur php-8.4.18/ext/xml/tests/bug81481.phpt php-8.4.20RC1/ext/xml/tests/bug81481.phpt
--- php-8.4.18/ext/xml/tests/bug81481.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/xml/tests/bug81481.phpt	2026-04-01 04:35:36.021985685 +0000
@@ -8,6 +8,7 @@
 memory_limit=-1
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 require __DIR__ . '/libxml_expat_skipif.inc';
 skipif(want_expat: false);
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
diff '--color=auto' -Naur php-8.4.18/ext/xsl/tests/auto_registration_namespaces_new_dom.phpt php-8.4.20RC1/ext/xsl/tests/auto_registration_namespaces_new_dom.phpt
--- php-8.4.18/ext/xsl/tests/auto_registration_namespaces_new_dom.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/xsl/tests/auto_registration_namespaces_new_dom.phpt	2026-04-01 04:35:36.022076427 +0000
@@ -24,7 +24,7 @@
 XML);
 
 // Make sure it will auto-register urn:test
-$sheet->documentElement->append($sheet->createElementNS('urn:test', 'test:dummy'));
+$sheet->documentElement->setAttributeNS('http://www.w3.org/2000/xmlns/', 'xmlns:test', 'urn:test');
 
 $input = Dom\XMLDocument::createFromString(<<<XML
 <root>
diff '--color=auto' -Naur php-8.4.18/ext/xsl/tests/gh21357_1.phpt php-8.4.20RC1/ext/xsl/tests/gh21357_1.phpt
--- php-8.4.18/ext/xsl/tests/gh21357_1.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/xsl/tests/gh21357_1.phpt	2026-04-01 04:35:36.022139876 +0000
@@ -0,0 +1,20 @@
+--TEST--
+GH-21357 (XSLTProcessor works with \DOMDocument, but fails with \Dom\XMLDocument)
+--EXTENSIONS--
+dom
+xsl
+--CREDITS--
+jacekkow
+--FILE--
+<?php
+$xml = <<<'XML'
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:tns="urn:myns" version="1.0">
+	<xsl:template match="tns:referee"/>
+</xsl:stylesheet>
+XML;
+
+$dom = Dom\XMLDocument::createFromString($xml);
+var_dump(new XSLTProcessor()->importStylesheet($dom));
+?>
+--EXPECT--
+bool(true)
diff '--color=auto' -Naur php-8.4.18/ext/xsl/tests/gh21357_2.phpt php-8.4.20RC1/ext/xsl/tests/gh21357_2.phpt
--- php-8.4.18/ext/xsl/tests/gh21357_2.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/ext/xsl/tests/gh21357_2.phpt	2026-04-01 04:35:36.022198928 +0000
@@ -0,0 +1,35 @@
+--TEST--
+GH-21357 (XSLTProcessor works with \DOMDocument, but fails with \Dom\XMLDocument)
+--EXTENSIONS--
+dom
+xsl
+--CREDITS--
+jacekkow
+--FILE--
+<?php
+$xsl = '<?xml version="1.0" encoding="utf-8"?>
+<xsl:stylesheet
+    version="1.0"
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+    xmlns:old="http://something/old/"
+    xmlns:new="http://something/new/">
+  <xsl:template match="node()|@*">
+    <xsl:copy>
+      <xsl:apply-templates select="node()|@*"/>
+    </xsl:copy>
+  </xsl:template>
+  <xsl:template match="old:*">
+    <xsl:element name="{local-name()}" xmlns="http://something/new/" >
+      <xsl:apply-templates select="node()|@*"/>
+    </xsl:element>
+  </xsl:template>
+</xsl:stylesheet>';
+$dom = Dom\XMLDocument::createFromString($xsl);
+$xsl = new XSLTProcessor();
+$xsl->importStylesheet($dom);
+var_dump($xsl->transformToXml(\Dom\XMLDocument::createFromString('<test xmlns="http://something/old/"/>')));
+?>
+--EXPECT--
+string(138) "<?xml version="1.0"?>
+<test xmlns="http://something/new/" xmlns:ns_1="http://www.w3.org/2000/xmlns/" ns_1:xmlns="http://something/old/"/>
+"
diff '--color=auto' -Naur php-8.4.18/ext/xsl/xsltprocessor.c php-8.4.20RC1/ext/xsl/xsltprocessor.c
--- php-8.4.18/ext/xsl/xsltprocessor.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/xsl/xsltprocessor.c	2026-04-01 04:35:36.022329404 +0000
@@ -123,65 +123,38 @@
 	}
 }
 
-static void xsl_add_ns_to_map(xmlHashTablePtr table, xsltStylesheetPtr sheet, const xmlNode *cur, const xmlChar *prefix, const xmlChar *uri)
+static void xsl_add_ns_def(xmlNodePtr node)
 {
-	const xmlChar *existing_url = xmlHashLookup(table, prefix);
-	if (existing_url != NULL && !xmlStrEqual(existing_url, uri)) {
-		xsltTransformError(NULL, sheet, (xmlNodePtr) cur, "Namespaces prefix %s used for multiple namespaces\n", prefix);
-		sheet->warnings++;
-	} else if (existing_url == NULL) {
-		xmlHashUpdateEntry(table, prefix, (void *) uri, NULL);
-	}
-}
+	if (node->type == XML_ELEMENT_NODE) {
+		for (xmlAttrPtr attr = node->properties; attr; attr = attr->next) {
+			if (php_dom_ns_is_fast((const xmlNode *) attr, php_dom_ns_is_xmlns_magic_token)) {
+				xmlNsPtr ns = xmlMalloc(sizeof(*ns));
+				if (!ns) {
+					return;
+				}
 
-/* Adds all namespace declaration (not using nsDef) into a hash map that maps prefix to uri. Warns on conflicting declarations. */
-static void xsl_build_ns_map(xmlHashTablePtr table, xsltStylesheetPtr sheet, php_dom_libxml_ns_mapper *ns_mapper, const xmlDoc *doc)
-{
-	const xmlNode *cur = xmlDocGetRootElement(doc);
+				bool should_free;
+				xmlChar *attr_value = php_libxml_attr_value(attr, &should_free);
 
-	while (cur != NULL) {
-		if (cur->type == XML_ELEMENT_NODE) {
-			if (cur->ns != NULL && cur->ns->prefix != NULL) {
-				xsl_add_ns_to_map(table, sheet, cur, cur->ns->prefix, cur->ns->href);
-			}
-
-			for (const xmlAttr *attr = cur->properties; attr != NULL; attr = attr->next) {
-				if (attr->ns != NULL && attr->ns->prefix != NULL && php_dom_ns_is_fast_ex(attr->ns, php_dom_ns_is_xmlns_magic_token)
-					&& attr->children != NULL && attr->children->content != NULL) {
-					/* This attribute declares a namespace, get the relevant instance.
-					 * The declared namespace is not the same as the namespace of this attribute (which is xmlns). */
-					const xmlChar *prefix = attr->name;
-					xmlNsPtr ns = php_dom_libxml_ns_mapper_get_ns_raw_strings_nullsafe(ns_mapper, (const char *) prefix, (const char *) attr->children->content);
-					xsl_add_ns_to_map(table, sheet, cur, prefix, ns->href);
-				}
+				memset(ns, 0, sizeof(*ns));
+				ns->type = XML_LOCAL_NAMESPACE;
+				ns->href = should_free ? attr_value : xmlStrdup(attr_value);
+				ns->prefix = attr->ns->prefix ? xmlStrdup(attr->name) : NULL;
+				ns->next = node->nsDef;
+				node->nsDef = ns;
 			}
 		}
-
-		cur = php_dom_next_in_tree_order(cur, (const xmlNode *) doc);
 	}
 }
 
-/* Apply namespace corrections for new DOM */
-typedef enum {
-	XSL_NS_HASH_CORRECTION_NONE = 0,
-	XSL_NS_HASH_CORRECTION_APPLIED = 1,
-	XSL_NS_HASH_CORRECTION_FAILED = 2
-} xsl_ns_hash_correction_status;
-
-static zend_always_inline xsl_ns_hash_correction_status xsl_apply_ns_hash_corrections(xsltStylesheetPtr sheetp, xmlNodePtr nodep, xmlDocPtr doc)
+static void xsl_add_ns_defs(xmlDocPtr doc)
 {
-	if (sheetp->nsHash == NULL) {
-		dom_object *node_intern = php_dom_object_get_data(nodep);
-		if (node_intern != NULL && php_dom_follow_spec_intern(node_intern)) {
-			sheetp->nsHash = xmlHashCreate(10);
-			if (UNEXPECTED(!sheetp->nsHash)) {
-				return XSL_NS_HASH_CORRECTION_FAILED;
-			}
-			xsl_build_ns_map(sheetp->nsHash, sheetp, php_dom_get_ns_mapper(node_intern), doc);
-			return XSL_NS_HASH_CORRECTION_APPLIED;
-		}
+	xmlNodePtr base = (xmlNodePtr) doc;
+	xmlNodePtr node = base->children;
+	while (node != NULL) {
+		xsl_add_ns_def(node);
+		node = php_dom_next_in_tree_order(node, base);
 	}
-	return XSL_NS_HASH_CORRECTION_NONE;
 }
 
 /* {{{ URL: http://www.w3.org/TR/2003/WD-DOM-Level-3-Core-20030226/DOM3-Core.html#
@@ -190,11 +163,11 @@
 PHP_METHOD(XSLTProcessor, importStylesheet)
 {
 	zval *id, *docp = NULL;
-	xmlDoc *doc = NULL, *newdoc = NULL;
+	xmlDoc *newdoc = NULL;
 	xsltStylesheetPtr sheetp;
 	bool clone_docu = false;
 	xmlNode *nodep = NULL;
-	zval *cloneDocu, rv;
+	zval *cloneDocu, rv, clone_zv;
 	zend_string *member;
 
 	id = ZEND_THIS;
@@ -202,51 +175,59 @@
 		RETURN_THROWS();
 	}
 
-	nodep = php_libxml_import_node(docp);
+	/* libxslt uses _private, so we must copy the imported
+	 * stylesheet document otherwise the node proxies will be a mess.
+	 * We will clone the object and detach the libxml internals later. */
+	zend_object *clone = Z_OBJ_HANDLER_P(docp, clone_obj)(Z_OBJ_P(docp));
+	if (!clone) {
+		RETURN_THROWS();
+	}
+
+	ZVAL_OBJ(&clone_zv, clone);
+	nodep = php_libxml_import_node(&clone_zv);
 
 	if (nodep) {
-		doc = nodep->doc;
+		newdoc = nodep->doc;
 	}
-	if (doc == NULL) {
+	if (newdoc == NULL) {
+		OBJ_RELEASE(clone);
 		zend_argument_type_error(1, "must be a valid XML node");
 		RETURN_THROWS();
 	}
 
-	/* libxslt uses _private, so we must copy the imported
-	stylesheet document otherwise the node proxies will be a mess */
-	newdoc = xmlCopyDoc(doc, 1);
-	xmlNodeSetBase((xmlNodePtr) newdoc, (xmlChar *)doc->URL);
+	php_libxml_node_object *clone_lxml_obj = Z_LIBXML_NODE_P(&clone_zv);
+
 	PHP_LIBXML_SANITIZE_GLOBALS(parse);
 	ZEND_DIAGNOSTIC_IGNORED_START("-Wdeprecated-declarations")
 	xmlSubstituteEntitiesDefault(1);
 	xmlLoadExtDtdDefaultValue = XML_DETECT_IDS | XML_COMPLETE_ATTRS;
 	ZEND_DIAGNOSTIC_IGNORED_END
 
+	if (clone_lxml_obj->document->class_type == PHP_LIBXML_CLASS_MODERN) {
+		xsl_add_ns_defs(newdoc);
+	}
+
 	sheetp = xsltParseStylesheetDoc(newdoc);
 	PHP_LIBXML_RESTORE_GLOBALS(parse);
 
 	if (!sheetp) {
-		xmlFreeDoc(newdoc);
+		OBJ_RELEASE(clone);
 		RETURN_FALSE;
 	}
 
 	xsl_object *intern = Z_XSL_P(id);
 
-	xsl_ns_hash_correction_status status = xsl_apply_ns_hash_corrections(sheetp, nodep, doc);
-	if (UNEXPECTED(status == XSL_NS_HASH_CORRECTION_FAILED)) {
-		xsltFreeStylesheet(sheetp);
-		xmlFreeDoc(newdoc);
-		RETURN_FALSE;
-	} else if (status == XSL_NS_HASH_CORRECTION_APPLIED) {
-		/* The namespace mappings need to be kept alive.
-		 * This is stored in the ref obj outside of libxml2, but that means that the sheet won't keep it alive
-		 * unlike with namespaces from old DOM. */
-		if (intern->sheet_ref_obj) {
-			php_libxml_decrement_doc_ref_directly(intern->sheet_ref_obj);
-		}
-		intern->sheet_ref_obj = Z_LIBXML_NODE_P(docp)->document;
-		intern->sheet_ref_obj->refcount++;
-	}
+	/* Detach object */
+	clone_lxml_obj->document->ptr = NULL;
+	/* The namespace mappings need to be kept alive.
+	 * This is stored in the ref obj outside of libxml2, but that means that the sheet won't keep it alive
+	 * unlike with namespaces from old DOM. */
+	if (intern->sheet_ref_obj) {
+		php_libxml_decrement_doc_ref_directly(intern->sheet_ref_obj);
+	}
+	intern->sheet_ref_obj = clone_lxml_obj->document;
+	intern->sheet_ref_obj->refcount++;
+	OBJ_RELEASE(clone);
 
 	member = ZSTR_INIT_LITERAL("cloneDocument", 0);
 	cloneDocu = zend_std_read_property(Z_OBJ_P(id), member, BP_VAR_R, NULL, &rv);
diff '--color=auto' -Naur php-8.4.18/ext/zip/php_zip.h php-8.4.20RC1/ext/zip/php_zip.h
--- php-8.4.18/ext/zip/php_zip.h	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/zip/php_zip.h	2026-04-01 04:35:36.022464820 +0000
@@ -39,7 +39,7 @@
 /* Additionnal flags not from libzip */
 #define ZIP_FL_OPEN_FILE_NOW (1u<<30)
 
-#define PHP_ZIP_VERSION "1.22.7"
+#define PHP_ZIP_VERSION "1.22.8"
 
 #ifdef HAVE_LIBZIP_VERSION
 #define LIBZIP_VERSION_STR zip_libzip_version()
diff '--color=auto' -Naur php-8.4.18/ext/zip/zip_stream.c php-8.4.20RC1/ext/zip/zip_stream.c
--- php-8.4.18/ext/zip/zip_stream.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/zip/zip_stream.c	2026-04-01 04:35:36.022537868 +0000
@@ -125,12 +125,11 @@
 	size_t path_len = strlen(stream->orig_path);
 	char file_dirname[MAXPATHLEN];
 	struct zip *za;
-	char *fragment;
 	size_t fragment_len;
 	int err;
 	zend_string *file_basename;
 
-	fragment = strchr(path, '#');
+	const char *fragment = strchr(path, '#');
 	if (!fragment) {
 		return -1;
 	}
@@ -286,14 +285,13 @@
 
 	struct zip *za;
 	struct zip_file *zf = NULL;
-	char *fragment;
 	size_t fragment_len;
 	int err;
 
 	php_stream *stream = NULL;
 	struct php_zip_stream_data_t *self;
 
-	fragment = strchr(path, '#');
+	const char *fragment = strchr(path, '#');
 	if (!fragment) {
 		return NULL;
 	}
diff '--color=auto' -Naur php-8.4.18/EXTENSIONS php-8.4.20RC1/EXTENSIONS
--- php-8.4.18/EXTENSIONS	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/EXTENSIONS	2026-04-01 04:35:35.982361296 +0000
@@ -170,57 +170,57 @@
 PRIMARY MAINTAINER:  Christian Stocker <chregu@php.net> (2003 - 2011)
                      Rob Richards <rrichards@php.net> (2003 - 2012)
                      Marcus Börger <helly@php.net> (2003 - 2006)
-                     Niels Dossche <nielsdos@php.net> (2023 - 2025)
-MAINTENANCE:         Maintained
+                     Nora Dossche <nielsdos@php.net> (2023 - 2026)
+MAINTENANCE:         Odd fixes
 STATUS:              Working
 SINCE:               5.0
 -------------------------------------------------------------------------------
 EXTENSION:           simplexml
 PRIMARY MAINTAINER:  Marcus Börger <helly@php.net> (2003 - 2008)
-                     Niels Dossche <nielsdos@php.net> (2023 - 2025)
-MAINTENANCE:         Maintained
+                     Nora Dossche <nielsdos@php.net> (2023 - 2026)
+MAINTENANCE:         Odd fixes
 STATUS:              Working
 SINCE:               5.0
 -------------------------------------------------------------------------------
 EXTENSION:           soap
 PRIMARY MAINTAINER:  Dmitry Stogov <dmitry@php.net> (2004 - 2018)
-                     Niels Dossche <nielsdos@php.net> (2024 - 2025)
+                     Nora Dossche <nielsdos@php.net> (2024 - 2026)
 MAINTENANCE:         Odd fixes
 STATUS:              Working
 -------------------------------------------------------------------------------
 EXTENSION:           xml
 PRIMARY MAINTAINER:  Thies C. Arntzen <thies@thieso.net> (1999 - 2002)
                      Rob Richards <rrichards@php.net> (2003 - 2013)
-                     Niels Dossche <nielsdos@php.net> (2023 - 2025)
-MAINTENANCE:         Maintained
+                     Nora Dossche <nielsdos@php.net> (2023 - 2026)
+MAINTENANCE:         Odd fixes
 STATUS:              Working
 -------------------------------------------------------------------------------
 EXTENSION:           libxml
 PRIMARY MAINTAINER:  Rob Richards <rrichards@php.net> (2003 - 2009)
                      Christian Stocker <chregu@php.net> (2004 - 2011)
-                     Niels Dossche <nielsdos@php.net> (2023 - 2025)
-MAINTENANCE:         Maintained
+                     Nora Dossche <nielsdos@php.net> (2023 - 2026)
+MAINTENANCE:         Odd fixes
 STATUS:              Working
 -------------------------------------------------------------------------------
 EXTENSION:           xmlreader
 PRIMARY MAINTAINER:  Rob Richards <rrichards@php.net> (2004 - 2010)
                      Christian Stocker <chregu@php.net> (2004 - 2004)
-                     Niels Dossche <nielsdos@php.net> (2023 - 2025)
-MAINTENANCE:         Maintained
+                     Nora Dossche <nielsdos@php.net> (2023 - 2026)
+MAINTENANCE:         Odd fixes
 STATUS:              Working
 -------------------------------------------------------------------------------
 EXTENSION:           xmlwriter
 PRIMARY MAINTAINER:  Rob Richards <rrichards@php.net> (2004 - 2010)
                      Pierre-Alain Joye <pajoye@php.net> (2005-2009)
-                     Niels Dossche <nielsdos@php.net> (2023 - 2025)
-MAINTENANCE:         Maintained
+                     Nora Dossche <nielsdos@php.net> (2023 - 2026)
+MAINTENANCE:         Odd fixes
 STATUS:              Working
 -------------------------------------------------------------------------------
 EXTENSION:           xsl
 PRIMARY MAINTAINER:  Christian Stocker <chregu@php.net> (2003 - 2011)
                      Rob Richards <rrichards@php.net> (2003 - 2010)
-                     Niels Dossche <nielsdos@php.net> (2023 - 2025)
-MAINTENANCE:         Maintained
+                     Nora Dossche <nielsdos@php.net> (2023 - 2026)
+MAINTENANCE:         Odd fixes
 STATUS:              Working
 SINCE:               5.0
 -------------------------------------------------------------------------------
@@ -486,8 +486,8 @@
 PRIMARY MAINTAINER:  John Coggeshall <john@php.net> (2003 - 2006)
                      Ilia Alshanetsky <iliaa@php.net> (2003 - 2009)
                      Nuno Lopes <nlopess@php.net> (2006 - 2012)
-                     Niels Dossche <nielsdos@php.net> (2025 - 2025)
-MAINTENANCE:         Maintained
+                     Nora Dossche <nielsdos@php.net> (2025 - 2026)
+MAINTENANCE:         Odd fixes
 STATUS:              Working
 -------------------------------------------------------------------------------
 EXTENSION:           tokenizer
diff '--color=auto' -Naur php-8.4.18/.github/actions/brew/action.yml php-8.4.20RC1/.github/actions/brew/action.yml
